#include <avr/io.h>

; Einstiegspunkte fr den Compiler deklarieren
.global ADD_TEST
.global ADDC_TEST
.global SUB_TEST
.global INC_TEST
.global DEC_TEST
.global MUL_TEST

; ********************* ADD_TEST *******************************************
ADD_TEST:  	PUSH	R31						; alte Registerwerte speichern
			PUSH	R30
			LDI     R31, 0xAA            	; Testmuster 1 laden
			LDI     R30, 0x55               ; Testmuster 2 laden
			ADD     R31, R30   	            ; Befehlstest
			CPI  	R31, 0xFF				; Vergleich mit Erwartungshaltung 
			BRNE 	ADD_err
			JMP		ARI_END1
ADD_err:    CALL 	testError


; ********************* ADDC_TEST *******************************************
ADDC_TEST:	CLC								; Das Carry-Bit lschen
			PUSH	R31						; alte Registerwerte speichern
			PUSH	R30
			LDI     R31, 0xFF            	; Testmuster 1 laden
			LDI     R30, 0x01              	; Testmuster 2 laden 
			ADC    	R31, R30  				; Befehlstest 
			BRCC	ADDC_err				; Vergleichen ob Carry-Bit gesetzt ist
			ADC    	R31, R30               	; Befehlstest
			CPI 	R31, 0x02				; Vergleich mit Erwartungshaltung 
			BRNE	ADDC_err
			NOP
ADDC_TEST2: JMP		ARI_END1
ADDC_err:   CALL 	testError 


; ********************* SUB_TEST *******************************************
SUB_TEST:  	PUSH	R31						; alte Registerwerte speichern
			PUSH	R30
			LDI     R31, 0xAA               ; Testmuster 1 laden
			LDI     R30, 0x55               ; Testmuster 2 laden 
			SUB    	R31, R30                ; Befehlstest 
			CPI		R31, 0x55			    ; Vergleich mit Erwartungshaltung
			BRNE	SUB_err
			
			JMP		ARI_END1
SUB_err:   	CALL 	testError               



; ********************* INC_TEST *******************************************
INC_TEST:  	PUSH	R31						; alte Registerwerte speichern
			LDI     R31, 0xFF               ; Testmuster 1 laden 
			INC     R31                     ; Befehlstest 
			CPI    	R31, 0x00				; Vergleich mit Erwartungshaltung 
			BRNE	INC_err
			JMP		ARI_END2
INC_err:   	CALL 	testError     


; ********************* DEC_TEST *******************************************
DEC_TEST:   PUSH	R31						; alte Registerwerte speichern
			LDI     R31, 0x00               ; Testmuster 1 laden
			DEC     R31                     ; Befehlstest
			CPI	    R31, 0xFF				; Vergleich mit Erwartungshaltung 
			BRNE	DEC_err
			JMP		ARI_END2
DEC_err:    CALL 	testError         


; ********************* MUL_TEST *******************************************
MUL_TEST:   PUSH	R31						; alte Registerwerte speichern
			PUSH	R30
			PUSH	R1
			PUSH	R0
			LDI     R31, 0xAA              	; Testmuster 1 laden
			LDI     R30, 0x55				; Testmuster 2 laden 
			MUL     R31, R30                ; Befehlstest
			MOV		R31, R1
			MOV		R30, R0
			CPI		R31, 0x38				; Vergleich mit Erwartungshaltung
			BRNE	MUL_err
			CPI	    R30, 0x72		       	; Vergleich mit Erwartungshaltung 
			BRNE	MUL_err
			JMP		ARI_END3
MUL_err:    CALL 	testError   


; ********************* ARI_END *******************************************
ARI_END1:	POP		R30						; alte Registerwerte wieder herstellen.
			POP		R31						; anschlieend zurck zum aufrufenden Programm springen
			RET
			
ARI_END2:	POP		R31
			RET
			
ARI_END3:	POP		R0
			POP		R1
			POP		R30
			POP		R31
			RET
