#include <avr/io.h>

.global AND_TEST
.global OR_TEST
.global EOR_TEST

; ********************* AND_TEST *******************************************
AND_TEST:   PUSH	R31
			PUSH	R30
			LDI     R31,0xAA		; Testmuster 1 laden
			LDI     R30,0x56        ; Testmuster 2 laden 
			AND     R31,R30         ; Befehlstest 
			CPI		R31, 0x02
			BRNE	AND_err			; Vergleich mit Erwartungshaltung
			POP		R30
			POP		R31
			RET
AND_err:    CALL 	testError		; Springe in Routine der Fehlermeldung

; ********************* OR_TEST  *****************************************
OR_TEST:   PUSH	R31
			PUSH	R30
			LDI     R31, 0xAA		; Testmuster 1 laden
			LDI		R30, 0x56       ; Testmuster 2 laden 
			OR     	R31, R30        ; Befehlstest 
			CPI	    R31, 0xFE		; Vergleich mit Erwartungshaltung
			BRNE	OR_err  
			POP		R30
			POP		R31      
			RET
OR_err:   	CALL 	testError		; Springe in Routine der Fehlermeldung

; ********************* EOR_TEST  *****************************************
EOR_TEST:  	PUSH	R31
			PUSH	R30
			LDI     R31, 0xAA       ; Testmuster 1 laden
			LDI     R30, 0x56       ; Testmuster 2 laden 
			EOR     R31, R30        ; Befehlstest 
			CPI		R31, 0xFC       ; Vergleich mit Erwartungshaltung
			BRNE	EOR_err
			POP		R30
			POP		R31
			RET
EOR_err:    CALL 	testError		; Springe in Routine der Fehlermeldung      
	