#include <avr/io.h>

.global mov_test
.global movw_test
.global ldi_test
.global ld_test


; ********************* MOV_TEST *******************************************
mov_test: 	push	R31			;Registerinhalt speichern
			push	R30
			ldi 	R30, 0xAA	;Werte zuweisen
			ldi		R31, 0x55
			mov		R31, R30	;Befehlstest
			cpi		R31, 0xAA	;berprfen
			brne	mov_err
			pop		R30			;Registerinhalt wiederherstellen
			pop		R31
			ret
mov_err:	CALL 	testError	; Springe in Routine der Fehlermeldung


; ********************* MOV_TEST *******************************************
movw_test:	push	R31			;Registerinhalt speichern
			push	R30
			push	R29
			push	R28
			ldi		R30, 0x55	;Werte zuweisen
			ldi		R31, 0xAA
			ldi		R28, 0xAA	
			ldi		R29, 0x55
			movw	R30, R28	;Befehlstest
			cpi		R30, 0xAA	
			brne	movw_err
			cpi		R31, 0x55
			brne	movw_err
			pop	R28				;Registerinhalt wiederherstellen
			pop	R29
			pop	R30
			pop	R31
			ret
movw_err:	CALL 	testError	; Springe in Routine der Fehlermeldung


; ********************* LDI_TEST *******************************************
ldi_test:	push	R31			;Registerinhalt speichern
			clr		R31			;Register lschen
			ldi		R31, 0x55	;befehlstest
			cpi		R31, 0x55
			brne	ldi_err
			pop		R31
			ret
ldi_err:	CALL 	testError	; Springe in Routine der Fehlermeldung


; ********************* LD_TEST *******************************************
ld_test:	push	R31			;Registerinhalte speichern
			push	R29
			push	R28
						
			IN		R28, _SFR_IO_ADDR(SPL)		;Stackpointeradresse in Y-Register schreiben
			IN		R29, _SFR_IO_ADDR(SPH)
			
			ldi		R31, 0x55
			push	R31			;Wert auf den Stack schreiben
			clr		R31
			clr		R31
			
			ld		R31, Y		;Wert abrufen
			cpi		R31, 0x55
			brne	ld_err
			
			pop		R28			;Ausgleichs-pop
			
			pop		R28			;Registerinhalt zurck schreiben
			pop		R29
			pop		R31
			ret
ld_err:		CALL 	testError	; Springe in Routine der Fehlermeldung
